Opened 5 years ago

Closed 5 years ago

#663 closed defect (fixed)

errors in sasview.log from structure factor

Reported by: pkienzle Owned by: wojciech
Priority: minor Milestone: SasView 4.1.0
Component: SasView Keywords:
Cc: Work Package: SasView Bug Fixing

Description

The following appeared in sasview.log on Windows for SasView 4.0b1 when setting the model to onion with a hard sphere structure factor, changing to a hayter msa structure factor. No data needed, just the Compute button.

2016-09-21 09:45:27,384 INFO building onion-float64 for OpenCL Intel(R) Xeon(R) CPU E5-2670 0 @ 2.60GHz
2016-09-21 09:45:51,720 INFO building hardsphere-float64 for OpenCL Intel(R) Xeon(R) CPU E5-2670 0 @ 2.60GHz
2016-09-21 09:45:51,720 INFO building hardsphere-float64 for OpenCL Intel(R) Xeo
n(R) CPU E5-2670 0 @ 2.60GHz
2016-09-21 09:45:58,913 ERROR Traceback (most recent call last):
  File "sas\sasgui\perspectives\fitting\basepage.pyc", line 1649, in _update_paramv_on_fit
  File "sas\sasgui\perspectives\fitting\basepage.pyc", line 879, in save_current_state
  File "sas\sascalc\calculator\BaseComponent.pyc", line 175, in clone
  File "copy.pyc", line 163, in deepcopy
  File "copy.pyc", line 298, in _deepcopy_inst
  File "copy.pyc", line 163, in deepcopy
  File "copy.pyc", line 257, in _deepcopy_dict
  File "copy.pyc", line 190, in deepcopy
  File "copy.pyc", line 334, in _reconstruct
  File "copy.pyc", line 163, in deepcopy
  File "copy.pyc", line 256, in _deepcopy_dict
RuntimeError: dictionary changed size during iteration

2016-09-21 09:45:58,974 INFO building hayter_msa-float64 for OpenCL Intel(R) Xeon(R) CPU E5-2670 0 @ 2.60GHz
2016-09-21 09:45:58,974 INFO building hayter_msa-float64 for OpenCL Intel(R) Xeon(R) CPU E5-2670 0 @ 2.60GHz

Note particularly that hardsphere and hayter-msa are being built twice, which suggests that two separate threads are trying to run the kernel at the same time. This may also explain the deepcopy problem if access to basepage objects are not threadsafe.

Onion is only being built once.

The computation appears to run, at least on Windows using an Intel CPU as the OpenCL device.

Change History (7)

comment:1 Changed 5 years ago by butler

  • Milestone changed from SasView 4.0.0 to SasView 4.1.0

It was agreed at the fortnightly meeting on Sep 27, 2016 that this problem is more than can be addressed in 3 days before the final release and further does not introduce any new annoyances then existed before …and does not seem to crash the GUI …but probably the source of things often being very very slow so do want to get to the bottom of this. Moving to 4.1

Last edited 5 years ago by ajj (previous) (diff)

comment:2 Changed 5 years ago by butler

testing during code camp after many changes to code including number of calls to models this works fine on my windows 10 machine running OpenCL. Instead of above I get in sasview.log

2016-10-11 10:16:22,302 INFO Doing help menu
2016-10-11 10:16:22,380 INFO Connected to www.sasview.org. Latest version: {
  "version": "3.1.2",
  "update_url": "http://www.sasview.org/sasview.latestversion",
  "download_url": "https://github.com/SasView/sasview/releases"
}
2016-10-11 10:17:05,519 INFO building onion-float64 for OpenCL Intel(R) Core(TM) i7-4500U CPU @ 1.80GHz
2016-10-11 10:17:14,653 INFO building hardsphere-float64 for OpenCL Intel(R) Core(TM) i7-4500U CPU @ 1.80GHz
2016-10-11 10:17:38,177 INFO building hayter_msa-float64 for OpenCL Intel(R) Core(TM) i7-4500U CPU @ 1.80GHz
2016-10-11 10:18:19,398 INFO  --- SasView session was closed --- 

Will ask a few other to check but otherwise will close this ticket

comment:3 Changed 5 years ago by butler

Ok seems to work on Wojcieck's mac and on his windows VM without OpenCL… However Richarch Heenan's machine without openCL shows the problem. May have to wait to check the jenkins build on several machines to ensure it is fixed?

comment:4 Changed 5 years ago by wojciech

On windows VM without opencl when change from hardsphere to hayter-msa retruns _handle error:

AttributeError: 'NoneType' object has no attribute '_handle'

It then seems to be working fine but this is something to investigate.
I deleted .sasmodels/compiled_models before running SasView

Last edited 5 years ago by butler (previous) (diff)

comment:5 Changed 5 years ago by butler

  • Priority changed from major to minor

comment:6 Changed 5 years ago by butler

  • Owner set to wojciech
  • Status changed from new to assigned

The original problem seems to be fixed, however the remaining problem identified by Wojcieck is throwing the same error and seems tobe similar to the propblem being worked on for ticket #778. Therefore, as discussed at the Oct 25 meeting, this is being assigned to Wojcieck for now. If it turns out not to be fixed with the other problem and too hard to do we will move it to the next release since it does not seem to prevent the program from running.

comment:7 Changed 5 years ago by wojciech

  • Resolution set to fixed
  • Status changed from assigned to closed
Note: See TracTickets for help on using tickets.